
import com.baomidou.mybatisplus.annotation.DbType;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.generator.AutoGenerator;
import com.baomidou.mybatisplus.generator.config.DataSourceConfig;
import com.baomidou.mybatisplus.generator.config.GlobalConfig;
import com.baomidou.mybatisplus.generator.config.PackageConfig;
import com.baomidou.mybatisplus.generator.config.StrategyConfig;
import com.baomidou.mybatisplus.generator.config.rules.DateType;
import com.baomidou.mybatisplus.generator.config.rules.NamingStrategy;
public class Mybatisplusgenerate2ApplicationTests {

    public static void main(String[] args) {
        // 1、创建代码生成器
        AutoGenerator mpg = new AutoGenerator();
        // 2、全局配置
        GlobalConfig gc = new GlobalConfig();
        gc.setOutputDir("C:\\projectxkf\\mtp3\\mtp3-generator\\src\\main\\java");
        gc.setAuthor("XKF");
        gc.setFileOverride(true); //重新生成时文件是否覆盖，默认是false不覆盖
        gc.setOpen(false);//是否打开输出目录
        gc.setIdType(IdType.AUTO); //主键策略
        gc.setDateType(DateType.ONLY_DATE);//定义生成的实体类中日期类型
        gc.setControllerName("%sController");
        gc.setServiceName("I%sService");
        gc.setServiceImplName("%sServiceImpl");
        gc.setMapperName("I%sMapper");
        gc.setXmlName("%sMapper");
        gc.setEntityName("%s");
        gc.setActiveRecord(true);
        gc.setBaseColumnList(true);
        gc.setBaseResultMap(true);
        gc.setEnableCache(false);
        gc.setSwagger2(true);//开启Swagger2模式
        mpg.setGlobalConfig(gc);

        // 3、数据源配置
        DataSourceConfig dsc = new DataSourceConfig();
        dsc.setUrl("jdbc:oracle:thin:@//192.168.31.88:1521/orcl");
        dsc.setDriverName("oracle.jdbc.OracleDriver");
        dsc.setUsername("MTP2_test204");
        dsc.setPassword("muchinfo");
        dsc.setDbType(DbType.ORACLE);
//        dsc.setDbQuery();//默认由 dbType 类型决定选择对应数据库内置实现
//        dsc.setSchemaName();
//        dsc.setTypeConvert();//默认由 dbType 类型决定选择对应数据库内置实现
//        dsc.setKeyWordsHandler();
        mpg.setDataSource(dsc);

        // 4、包配置
        PackageConfig pc = new PackageConfig();
        pc.setModuleName("clear"); //模块名
        pc.setParent("com.muchinfo.generator");
        pc.setController("controller");
        pc.setEntity("entity");
        pc.setService("service");
        pc.setMapper("mapper");
        mpg.setPackageInfo(pc);

        // 5、策略配置
        StrategyConfig strategy = new StrategyConfig();
        strategy.setNaming(NamingStrategy.underline_to_camel);//数据库表映射到实体的命名策略
        strategy.setColumnNaming(NamingStrategy.underline_to_camel);//数据库表字段映射到实体的命名策略
        strategy.setTablePrefix();//生成实体时去掉表前缀
        strategy.setFieldPrefix();//生成实体时去掉字段前缀
//      表名大小写敏感
//        strategy.setInclude("product_class", "product");//需要包含的表名，当 enableSqlFilter 为 false 时，允许正则表达式（与 exclude 二选一配置）
        strategy.setInclude("RECKON_DAYDIVIDECOUNTDETAIL");//需要包含的表名，当 enableSqlFilter 为 false 时，允许正则表达式（与 exclude 二选一配置）

//        strategy.setExclude("product_class");//需要排除的表名，当 enableSqlFilter 为 false 时，允许正则表达式
//        strategy.setEnableSqlFilter(true);//默认激活进行 sql 模糊表名匹配 关闭之后 likeTable 与 notLikeTable 将失效，include 和 exclude 将使用内存过滤
//        strategy.setLikeTable(new LikeTable(""));//模糊匹配表名（与 notLikeTable 二选一配置）
//        strategy.setNotLikeTable(new LikeTable(""));//模糊排除表名

        strategy.setEntityColumnConstant(false);//【实体】是否生成字段常量（默认 false）
        strategy.setChainModel(true);//【实体】是否为链式模型（默认 false）
        strategy.setEntityLombokModel(true); //【实体】是否为lombok模型（默认 false） @Accessors(chain = true) setter链式操作 如有需要，请开启 chainModel

        strategy.setEntityBooleanColumnRemoveIsPrefix(false);//Boolean 类型字段是否移除 is 前缀（默认 false）
        strategy.setEntityTableFieldAnnotationEnable(true);//是否生成实体时，生成字段注解
        strategy.setRestControllerStyle(true); //restful api风格控制器
        strategy.setControllerMappingHyphenStyle(true); //url中驼峰转连字符
        mpg.setStrategy(strategy);


        // 6、执行
        mpg.execute();
    }
}
